package fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

public class IdentificationDataSourceSet extends
		HashSet<IdentificationDataSource> {

	private static final long serialVersionUID = -4351959247611214080L;

	private static final Logger logger = Logger
			.getLogger(IdentificationDataSourceSet.class);

	private HashMap<String, IdentificationDataSource> stringToDatasource = new HashMap<String, IdentificationDataSource>();

	public IdentificationDataSourceSet() {
	}

	public IdentificationDataSource getInstance(String source)
			throws MSMSException {
		// If exist, return instance
		IdentificationDataSource dataSource = null;
		if (stringToDatasource.containsKey(source)) {
			dataSource = stringToDatasource.get(source);
		} else {
			// If not exist create correct instance
			if (XtandemPipelineSession.getInstance().isPROTICportDataSource() == false) {
				if (source.matches(".*dat$")) {
					dataSource = new IdentificationMascotFile(new File(source));
					stringToDatasource.put(source, dataSource);
					// }else if(source.matches(".*xml$")){
				} else {
					dataSource = new IdentificationXtandemFile(new File(source));
				}
			} else {
				logger.debug("PP");
				dataSource = new IdentificationProticPortSource(
						new Long(source));
			}
			stringToDatasource.put(source, dataSource);
			logger.debug("New Datasource :" + source);
		}
		if (dataSource == null) {
			String message = "dataSource is null for key : " + source;
			logger.error(message);
			throw new MSMSException(message);
		}
		return (dataSource);
	}

}
