package fr.inra.pappso.xtandempipeline.class_msms;

public class Modifs implements Comparable<Modifs>  {

	private String AA;
	private int posi;
	private int posi_in_prot;
	private float modvalue;
	private boolean isotopic;
	
	// constructeur
	public Modifs(float _modvalue) {
		this.modvalue = _modvalue;
		this.isotopic = false;
	}

	public Modifs(String _AA, int _posi, float _modvalue) {
		this.AA = _AA;
		this.posi = _posi;
		this.modvalue = _modvalue;
		this.isotopic = false;
		this.posi_in_prot = 0;
	}
	
	public int compareTo(Modifs p) {
		int k = (int) ((this.modvalue - p.get_modvalue())*100);
		return (k);
	}	
	
	public void set_AA(String f) {
		this.AA = f;
	}
	public void set_posi(int f) {
		this.posi = f;
	}
	public void set_modvalue(float f) {
	this.modvalue = f;
	}
	
	public String get_AA() {
		return(this.AA);
	}
	public int get_posi() {
		return(this.posi);
	}
	public float get_modvalue() {
		return(this.modvalue);
	}
	public String get_formater_value() {
		String f = this.AA+this.posi;
		if (this.modvalue>0)
			f = f+":+"+this.modvalue;
		else
			f = f+":"+this.modvalue;
		return(f);
	}

	public boolean is_phopho_modifs() {
		if ((this.modvalue > 79.9)&(this.modvalue < 80.1))
			return true;
		boolean serthre = false;
		if (this.AA.equals("T"))
			serthre = true;
		else if (this.AA.equals("S"))
			serthre = true;
		if ((serthre)&(this.modvalue < -17.9)&(this.modvalue > -18.1))
			return true;
		return false;
	}

	public void setIsotopic(boolean isotopic) {
		this.isotopic = isotopic;
	}

	public boolean isIsotopic() {
		return isotopic;
	}
	public String toString(){
		if (modvalue==0)
			return("No isotope labelling");
		return(""+modvalue);
	}

	public void setPosi_in_prot(int posi_in_prot) {
		this.posi_in_prot = posi_in_prot;
	}

	public int getPosi_in_prot() {
		return posi_in_prot;
	}
}