package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.GroupSet;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetPhospho;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;

public class print_ods_compar_phospho extends printOdsBase {

	public print_ods_compar_phospho(OdsDocWriter odsTable, MsRunSet samp) {
		super(odsTable, samp);
		logger.info("Print Compar file in phospho mode ODS");
	}

	public void print_header() throws Exception {

		odsTable.writeLine();
		// out.write(samp.getSampleName() + "\n");
		ArrayList<String> headStrList = new ArrayList<String>();
		headStrList.add("Group");
		headStrList.add("Sub-group");
		headStrList.add("Description");
		headStrList.add("Redundancy");
		headStrList.add("Position");
		for (MsRun sample : samples.getMsRunList()) {
			// S = S + "\t" + sample.getSampleName();
			headStrList.add(sample.getSampleName());
		}
		headStrList.add("Type");

		for (String title : headStrList) {
			odsTable.writeCell(title);
		}
	}

	@Override
	public void execute(GroupSet grouping) throws Exception {
		odsTable.writeSheet("compar_Spectra");
		this.print_header();
		for (Group group : grouping.getGroupList()) {
			this.print_group_information(group, "Spectra");
		}
		// out.write("\n");

		// for(Group group : grouping.getGroupList()){
		// this.print_group_information(group, "Specific");
		// }
		// out.write("\n");
		
		odsTable.writeSheet("compar_Unique");
		this.print_header();
		for (Group group : grouping.getGroupList()) {
			this.print_group_information(group, "Unique");
		}
		// out.write("\n");
		//
		// for(Group group : grouping.getGroupList()){
		// this.print_group_information(group, "PAI");
		// }
		// out.write("\n");
	}

	public void print_group_information(Group group, String type)
			throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			odsTable.writeLine();

			String subgroup = this.get_subgroup_number(group, sg);
			ArrayList<HashSampleScanSetProt> hprotlist = sg
					.getHashSampleScanSetProtList();

			HashSampleScanSetPhospho phospho = (HashSampleScanSetPhospho) hprotlist
					.get(0);

			// données des
			//StringBuilder S = new StringBuilder();
			odsTable.writeCell(""+group.getNumber());
			//S.append(group.getNumber());
			odsTable.writeCell(subgroup);
			//S.append("\t" + subgroup);
			odsTable.writeCell(phospho.getMatch().get_protein_match().get_description());
		//S.append("\t"
			//		+ phospho.getMatch().get_protein_match().get_description());
			if (hprotlist.size() > 1){
				odsTable.writeCell(hprotlist.size() + "*");
				//S.append("\t" + hprotlist.size() + "*");
			}
			else {
				odsTable.writeCell("-");
				//S.append("\t" + "\"-\"");
			}

			odsTable.writeCell(phospho.getPhosphoPositionToPrint());
			//S.append("\t" + phospho.getPhosphoPositionToPrint());

			// On ecris les données pour chaque sample
			float value = 0;
			for (MsRun sample : samples.getMsRunList()) {
				if (type.equals("Spectra"))
					value = phospho.getTotalHashSampleScantoMsRun(sample);

				if (type.equals("Unique")) {
					value = phospho
							.getUniqueHashPeptideSampleScantoMsRun(sample);
				}
				if (value > 0) {
					odsTable.writeCell(new Double(value));
					//S.append("\t" + value);
				}
				else {
					odsTable.writeCell("");
					//S.append("\t");
				}

			}
			odsTable.writeCell(type);
			//S.append("\t" + type + "\n");
			//out.write(S.toString());

		}
	}

}
