package fr.inra.pappso.xtandempipeline.thread;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.filter_print.print_compar_phospho;
import fr.inra.pappso.xtandempipeline.filter_print.print_ods_compar_phospho;
import fr.inra.pappso.xtandempipeline.filter_print.print_ods_peptide_list_to_phosphopeptide;
import fr.inra.pappso.xtandempipeline.filter_print.print_ods_protein_to_phosphopeptide;
import fr.inra.pappso.xtandempipeline.filter_print.print_peptide_list_to_phosphopeptide;
import fr.inra.pappso.xtandempipeline.filter_print.print_protein_to_phosphopeptide;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class printing_phosphopeptide extends printing_base {

	public printing_phosphopeptide(config conf) {
		super(conf);
	}

	protected OdsDocWriter ods_specific_printing(String filename) throws Exception {
		OdsDocWriter odsDoc = new OdsDocWriter(filename);
		logger.info("Print phophopeptide results ODS");

		this.set_view("Printing protein file results");
		odsDoc.writeSheet("proteins");
		//msms_output output = new msms_output();
		//output.open(this.getfileout().getAbsolutePath() + "_protein.txt");
		// protein view
		for (Identification ident : this.identifications) {
			ident.print_result(new print_ods_protein_to_phosphopeptide(odsDoc));
		}

		//output.close();

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing peptide file results");
		//output.open(this.getfileout().getAbsolutePath() + "_peptide.txt");
		odsDoc.writeSheet("peptides");

		// peptide list
		for (Identification ident : this.identifications) {
			ident.print_result(new print_ods_peptide_list_to_phosphopeptide(odsDoc));
		}
		//output.close();

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar file results");
		//odsDoc.writeSheet("compar");
		//output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			ident.print_result(new print_ods_compar_phospho(odsDoc, ident
					.get_samples()));
		}
		//output.close();

		this.add_current_progress();
		return odsDoc;
	}

	protected void specific_printing() throws Exception {
		logger.info("Print phophopeptide results");

		this.set_view("Printing protein file results");
		msms_output output = new msms_output();
		output.open(this.getfileout().getAbsolutePath() + "_protein.txt");
		// protein view
		for (Identification ident : this.identifications) {
			ident.print_result(new print_protein_to_phosphopeptide(output));
		}

		output.close();

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing peptide file results");
		output.open(this.getfileout().getAbsolutePath() + "_peptide.txt");
		// peptide list
		for (Identification ident : this.identifications) {
			ident.print_result(new print_peptide_list_to_phosphopeptide(output));
		}
		output.close();

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar file results");
		output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			ident.print_result(new print_compar_phospho(output, ident
					.get_samples()));
		}
		output.close();

		this.add_current_progress();
	}

}
