package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;
import java.util.Collections;

import fr.inra.pappso.xtandempipeline.class_msms.Peptide;

public class calculation_peptide_mh_deviation extends calculation_base_peptide {

	private double sum;

	private ArrayList<Float> list_value_diff;

	private boolean is_ppm;

	public calculation_peptide_mh_deviation(boolean is_ppm) {
		super();
		this.is_ppm = is_ppm;
		list_value_diff = new ArrayList<Float>();
		sum = 0;
		logger.info("Calculation of peptide mass deviation");
	}

	protected void processing_peptide(Peptide pep) {
		if (pep.isValidate()) {
			float diff = pep.get_mhplus_theo() - pep.get_mhplus_obser();
			if (is_ppm) {
				while (diff < -0.5)
					diff = diff + (float) 1.007894;
				diff = (diff / pep.get_mhplus_theo()) * 1000000;
			}
			sum += diff;
			list_value_diff.add(diff);
		}
	}

	public float get_mean_deviation() {
		float mean = (float) (sum / list_value_diff.size());
		return (mean);
	}

	public float get_mediane_deviation() {
		Collections.sort(list_value_diff);
		int med = (int) list_value_diff.size() / 2;
		return list_value_diff.get(med);
	}

	public float get_standart_deviation() {
		float var = 0;
		float mean = this.get_mean_deviation();
		for (float val : list_value_diff) {
			var = var + ((val - mean) * (val - mean));
		}
		var = var / list_value_diff.size();
		return (float) Math.sqrt(var);
	}
}
