package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MatchList;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;

public class filter_peptide_evalue extends filter_base {
	
	private float peptide_evalue;

	public filter_peptide_evalue(float evalue){
		super();
		this.peptide_evalue = evalue;
		logger.info("Filter peptide on Evalue : "+evalue);
	}
	
	public int execute(MatchList m){
		//processing de la match_list
		for (Match ms : m.getMatchListes()) {
			ArrayList<Peptide> peps = ms.get_all_peptides();
			for(Peptide pep : peps){
				if (pep.get_evalue()>=this.peptide_evalue)
					pep.setValidate(false);
			}
			if (ms.get_valid_peptide_number()>0){
				numberOfValidMatch++;
			}else{
				ms.setIsvalidate(false);
			}
		}
		return (this.numberOfValidMatch);
	}

}
