package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScan;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.grouping.SubGroupSet;

public class print_ods_peptide_list extends printOdsBase {


	public print_ods_peptide_list(OdsDocWriter odsTable) {
		super(odsTable);
		logger.info("Print Peptide liste file in normal mode");
	}

	public void print_header() throws Exception {

		odsTable.writeLine();
		// out.write(samp.getSampleName() + "\n");
		ArrayList<String> headStrList = new ArrayList<String>();
		headStrList.add("Group");
		headStrList.add("Description");
		headStrList.add("Sample");
		headStrList.add("Scan");
		headStrList.add("Rt");
		headStrList.add("Sequence");
		headStrList.add("Modifs");
		headStrList.add("Used");
		headStrList.add("on a total of");
		headStrList.add("Sub-groups");
		headStrList.add("E-value");
		headStrList.add("Charge");
		headStrList.add("MH+ Obs");
		headStrList.add("MH+ theo");
		headStrList.add("DeltaMH+");
		headStrList.add("Delta-ppm");

		for (String title : headStrList) {
			odsTable.writeCell(title);
		}
	}

	public void print_group_information(Group group) throws Exception {
		logger.debug("printing group "+ group.getNumber());
		for (HashSampleScan hash : group.getHashSampleScanSet()
				.getHashSampleScanList()) {
			odsTable.writeLine();
			
			SubGroupSet set = group.getSubGroupContaining(hash);
			ArrayList<SubGroup> sgList = set.getSubGroupList();
			Match top = sgList.get(0).getHashSampleScanSetProtList().get(0)
					.getMatch();
			Peptide pep = top.getBestPeptideToHashSampleScan(hash);
			
			
			
			//StringBuilder S = new StringBuilder();

			// on rempli
			odsTable.writeCell("" + group.getNumber());
			//S.append(group.getNumber() + "\t");
			if (set.size() == 1) {
				odsTable.writeCell(top.get_protein_match().get_description());
				//S.append(top.get_protein_match().get_description());
			}
			else {
				odsTable.writeCell("");	
			}
			odsTable.writeCell(hash.getMsRun().getSampleName());
			//S.append("\t" + hash.getMsRun().getSampleName());
			odsTable.writeCell(hash.getScan());
			//S.append("\t" + hash.getScan());
			odsTable.writeCell(pep.get_RT());
			//S.append("\t" + pep.get_RT());
			odsTable.writeCell( pep.get_sequence());
			//S.append("\t" + pep.get_sequence());
			odsTable.writeCell( pep.get_Modifs_formater());
			//S.append("\t" + pep.get_Modifs_formater());

			if (set.size() > 1) {
				odsTable.writeCell(set.size());

				odsTable.writeCell(group.getSubGroupSet().size());
				//S.append("\t" + set.size() + "\t"
				//		+ group.getSubGroupSet().size());
			}
			else {
				odsTable.writeCell(  "-");

				odsTable.writeCell(  "-");
//S.append("\t" + "\"-\"" + "\t" + "\"-\"");
			}
			//S.append("\t");
			// match[] order = m.get_match_order();
			boolean second = false;
			StringBuilder S = new StringBuilder("");
			for (SubGroup sub : sgList) {
				if (second) {
					S.append(" ");
				}
				S.append(this.get_subgroup_number(group, sub));
				second = true;
			}
			odsTable.writeCell(  S.toString());

			odsTable.writeCell(pep.get_evalue());
			//S.append("\t" + pep.get_evalue());
			odsTable.writeCell(pep.get_charge());
			//S.append("\t" + pep.get_charge());
			odsTable.writeCell(pep.get_mhplus_obser());
			//S.append("\t" + pep.get_mhplus_obser());
			odsTable.writeCell(pep.get_mhplus_theo());
			//S.append("\t" + pep.get_mhplus_theo());
			odsTable.writeCell( pep.get_deltamass());
			//S.append("\t" + pep.get_deltamass());
			odsTable.writeCell( ((pep.get_deltamass() / pep.get_mhplus_theo()) * 1000000));
			//S.append("\t"
			//		+ ((pep.get_deltamass() / pep.get_mhplus_theo()) * 1000000));
		}
		odsTable.writeLine();
		//out.write("\n");
	}

}
