package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScan;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.grouping.SubGroupSet;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_peptide_list extends print_base {

	public print_peptide_list(msms_output out) {
		super(out);
		logger.info("Print Peptide liste file in normal mode");
	}

	public void print_header() throws Exception {
		String S = "Groupe" + "\t" + "Description" + "\t" + "Sample" + "\t"
				+ "Scan" + "\t" + "Rt" + "\t" + "Sequence" + "\t" + "Modifs"
				+ "\t" + "Used" + "\t" + "on a total of"
				+ "\t"
				+ "Sub-groups" + "\t" + "E-value" + "\t" + "Charge" + "\t"
				+ "MH+ Obs" + "\t" + "MH+ theo" + "\t" + "DeltaMH+" + "\t"
				+ "Delta-ppm" + "\n";
		out.write(S);
	}

	public void print_group_information(Group group) throws Exception {
		for (HashSampleScan hash : group.getHashSampleScanSet()
				.getHashSampleScanList()) {
			SubGroupSet set = group.getSubGroupContaining(hash);
			ArrayList<SubGroup> sgList = set.getSubGroupList();
			Match top = sgList.get(0).getHashSampleScanSetProtList().get(0).getMatch();
			Peptide pep = top.getBestPeptideToHashSampleScan(hash);
			StringBuilder S = new StringBuilder();

			// on rempli
			S.append(group.getNumber() + "\t");
			if (set.size() == 1)
				S.append(top.get_protein_match().get_description());
			S.append("\t" + hash.getMsRun().getSampleName());
			S.append("\t" + hash.getScan());
			S.append("\t" + pep.get_RT());
			S.append("\t" + pep.get_sequence());
			S.append("\t" + pep.get_Modifs_formater());

			if (set.size() > 1)
				S.append("\t" + set.size() + "\t"
						+ group.getSubGroupSet().size());
			else
				S.append("\t" + "\"-\"" + "\t" + "\"-\"");
			S.append("\t");
			// match[] order = m.get_match_order();
			boolean second = false;
			for (SubGroup sub : sgList) {
				if (second) {
					S.append(" ");
				}
				S.append(this.get_subgroup_number(group, sub));
				second = true;
			}

			S.append("\t" + pep.get_evalue());
			S.append("\t" + pep.get_charge());
			S.append("\t" + pep.get_mhplus_obser());
			S.append("\t" + pep.get_mhplus_theo());
			S.append("\t" + pep.get_deltamass());
			S.append("\t"
					+ ((pep.get_deltamass() / pep.get_mhplus_theo()) * 1000000));
			S.append("\n");
			out.write(S.toString());
		}
		out.write("\n");
	}

}
