package fr.inra.pappso.xtandempipeline.filter_print;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_protein_to_indiv extends print_base {

	public print_protein_to_indiv(msms_output out, MsRunSet sample) {
		super(out, sample);
		logger.info("Print Protein liste file in Individual mode");
	}

	public void print_header(MsRun samp) throws Exception {
		out.write(samp.getSampleName() + "\n");
		String S = "Group" + "\t" + "Sub-group" + "\t" + "Description" + "\t"
				+ "log(E value)" + "\t" + "Coverage" + "\t" + "MW" + "\t"
				+ "Spectra" + "\t" + "Specifics" + "\t" + "Uniques" + "\t"
				+ "PAI" + "\t" + "Redundancy" + "\n";
		out.write(S);
	}

	public void print_group_information_to_sample(Group group, MsRun sample)
			throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			for (HashSampleScanSetProt hashProt : sg.getHashSampleScanSetProtList()) {
				StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();
				S.append(group.getNumber() + "\t" + this.get_subgroup_number(group, sg) + "\t"
						+ top.get_protein_match().get_description());
				S.append("\t" + top.get_protein_match().get_evalue(sample));
				S.append("\t" + top.get_coverage_to(sample));
				S.append("\t" + top.get_protein_match().get_mw());
				S.append("\t" + top.get_valid_peptide_number_to(sample));
				if(group.getSubGroupSet().size() > 1)
					S.append("\t"
							+ group.getNumberOfSpecificPeptideInSubGroupToSample(hashProt, sample));
				else
					S.append("\t" + "\"-\"");
				S.append("\t" + top.get_unique_valid_peptide_number_to(sample));
				S.append("\t");
				S.append((float) top.get_spectra_numbers_to(sample)
						/ top.get_protein_match().get_PAI_count() + "\t");
				if (sg.getHashSampleScanSetProtSet().size() > 1)
					S.append("* " + sg.getHashSampleScanSetProtSet().size());
				S.append("\n");
				out.write(S.toString());

			}
		}
		out.write("\n");
	}

}
